;Colour bars program
;-------------------
;Binary created using DAsm 2.12 running on an Amiga.

   PROCESSOR   6502

   ORG   $C000    ;16Kb PRG-ROM, 8Kb CHR-ROM

Reset_Routine  SUBROUTINE
   cld         ;Clear decimal flag
   sei         ;Disable interrupts
.WaitV   lda $2002
   bpl .WaitV     ;Wait for vertical blanking interval
   ldx #$00
   stx $2000
   stx $2001      ;Screen display off, amongst other things
   dex
   txs         ;Top of stack at $1FF

;Clear (most of) the NES' WRAM. This routine is ripped from "Duck Hunt" - I should probably clear all
;$800 bytes.
   ldy #$06    ;To clear 7 x $100 bytes, from $000 to $6FF?
   sty $01        ;Store count value in $01
   ldy #$00
   sty $00
   lda #$00

.Clear   sta ($00),y    ;Clear $100 bytes
   dey
   bne .Clear

   dec $01        ;Decrement "banks" left counter
   bpl .Clear     ;Do next if >= 0


   lda   #$20
   sta   $2006
   lda   #$00
   sta   $2006

   ldx   #$00
   ldy   #$10
.ClearPPU sta $2007
   dex
   bne   .ClearPPU
   dey
   bne   .ClearPPU

   lda   #$00
   sta   $2003
   tay
.ClearSpr sta   $2004
   dey
   bne   .ClearSpr

;********* Initialize Palette to specified colour ********

   ldx   #$3F
   stx   $2006
   ldx   #$00
   stx   $2006

   ldx   #$00
   ldy   #$20     ;Set BG & Sprite palettes.
.InitPal lda   .Palette,X
   sta $2007
   inx
   dey
   bne   .InitPal

;*********************************************************

;********* Set up Name & Attributes ******************

   lda   #<.CMCMap
   sta   $00
   lda   #>.CMCMap
   sta   $01

   lda   #$20        ;Load up entire name & attribute table for screen 0.
   sta   $2006
   lda   #$00
   sta   $2006

   ldx   #$00
   ldy   #$04

.LoadDeck
   txa
   pha

   ldx   #$00
   lda   ($00),X     ;Load up NES image
   sta   $2007

   pla
   tax

   inc   $00
   bne   .NoDeck1
   inc   $01

.NoDeck1
   dex
   bne   .LoadDeck
   dey
   bne   .LoadDeck

   lda   #$00
   sta   $2003
   lda   #$08
   sta   $2004
   lda   #$01
   sta   $2004
   lda   #$02
   sta   $2004
   lda   #$0C
   sta   $2004

   lda   #$09
   sta   $2004
   lda   #$02
   sta   $2004
   lda   #$00
   sta   $2004
   lda   #$08
   sta   $2004

   lda   #$09
   sta   $2004
   lda   #$03
   sta   $2004
   lda   #$00
   sta   $2004
   lda   #$10
   sta   $2004

   lda   #$11
   sta   $2004
   lda   #$04
   sta   $2004
   lda   #$01
   sta   $2004
   lda   #$08
   sta   $2004

   lda   #$11
   sta   $2004
   lda   #$05
   sta   $2004
   lda   #$01
   sta   $2004
   lda   #$10
   sta   $2004

   lda   #$00
   sta   $2005
   sta   $2005

;************************************


;Enable vblank interrupts, etc.
   lda   #%10001000
   sta   $2000
   lda   #%00011110        ;Screen on, sprites on, show leftmost 8 pixels, colour
   sta   $2001
;  cli            ;Enable interrupts(?)

;Now just loop forever?
.Loop jmp   .Loop

.Palette dc.b #$0D,#$00,#$10,#$30,#$0D,#$21,#$31,#$30
         dc.b #$0D,#$27,#$3D,#$30,#$0D,#$26,#$38,#$30
         dc.b #$0D,#$19,#$28,#$17,#$0D,#$16,#$14,#$01
         dc.b #$0D,#$19,#$30,#$30,#$0D,#$0D,#$0D,#$0D

.CMCMap
   INCLUDE MacLarge.nam


NMI_Routine SUBROUTINE
   rti

IRQ_Routine       ;Dummy label
   rti

;That's all the code. Now we just need to set the vector table approriately.

   ORG   $FFFA,0
   dc.w  NMI_Routine
   dc.w  Reset_Routine
   dc.w  IRQ_Routine    ;Not used, just points to RTI


;The end.
